/********************************* Class Declaration ***************************/
/**
\package  _uc_WebView - 
\class    OWEBControl (Build: 269)

\brief    


\date     $Date: 2011-10-10 20:07:49.10 $
\note     dbsource gui.dev - ODABA Version 11.2.0

          Copyright (C) 1994-2011 Run Software GmbH.
 
          This program is free software: you can redistribute it and/or modify
          it under the terms of the GNU General Public License as published by
          the Free Software Foundation, either version 3 of the License, or
          (at your option) any later version.
 
          This program is distributed in the hope that it will be useful,
          but WITHOUT ANY WARRANTY; without even the implied warranty of
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
          GNU General Public License 3.0 for more details.
 
          You should have received a copy of the GNU General Public License
          along with this program. If not, see <http://www.gnu.org/licenses/>.

*/
/******************************************************************************/
#pragma once
class OWEBControl;

class QComboBox;
class QString;
class QToolBar;
class QVBoxLayout;
class QWidget;
class UserControlHandle;
#include  <Common/h/OHTMLControlBase.hpp>
#include  <h/cqt.h>
#include  <ogui/h/UserControl.hpp>

class  OWEBControl    : public OHTMLControlBase                                  ,
public UserControl                                       
{


private    :                                                      Q_OBJECT;                                                  // 
protected  :         QAction                                     *actionReload;                                              // 
protected  :         QAction                                     *actionZoomDefault;                                         // 
protected  :         QAction                                     *actionZoomIn;                                              // 
protected  :         QAction                                     *actionZoomOut;                                             // 
protected  :         QAction                                     *actionBackward;                                            // 
protected  :         QAction                                     *actionForward;                                             // 
protected  :         bool                                         pageIsLoading;                                             // 
protected  :         QVBoxLayout                                 *layout;                                                    // 
protected  :         QComboBox                                   *historyComboBox;                                           // 
protected  :         QWidget                                     *panel;                                                     // 
protected  :         QToolBar                                    *toolbar;                                                   // 
protected  :         QWebView                                    *webView;                                                   // 

public     :
                     QAction                                     *get_actionReload() { return(actionReload); }
                     QAction                                     *get_actionZoomDefault() { return(actionZoomDefault); }
                     QAction                                     *get_actionZoomIn() { return(actionZoomIn); }
                     QAction                                     *get_actionZoomOut() { return(actionZoomOut); }
                     QAction                                     *get_actionBackward() { return(actionBackward); }
                     QAction                                     *get_actionForward() { return(actionForward); }
                     bool                                        &get_pageIsLoading() { return(pageIsLoading); }
                     QVBoxLayout                                 *get_layout() { return(layout); }
                     QComboBox                                   *get_historyComboBox() { return(historyComboBox); }
                     QWidget                                     *get_panel() { return(panel); }
                     QToolBar                                    *get_toolbar() { return(toolbar); }
                     QWebView                                    *get_webView() { return(webView); }
public     :                                             OWEBControl (UserControlHandle *pUserControlHandle, QWidget *parent );
public     :                                        void ProvideToolBar ( );
public     :                                        void RemoveToolBar ( );
public     :  virtual                               void activate ( );
public     :  virtual                               void clearData ( );
public     :  virtual                               void deactivate ( );
public     :  virtual                               void fillData ( );
public     :  virtual                               void ohev_beforeSetUrl (const QString &rcQString, const QUrl &link );
public     :  virtual                               const QString ohget_documentTitle ( );
public     :  virtual                               QComboBox *ohget_historyComboBox ( );
public     :  virtual                               void ohrea_addResourcePath (const QString &resourcePath );
public     :  virtual                               bool ohrea_removeResourcePath (const QString &resourcePath );
public     :  virtual                               bool ohrea_resourcePathExists (const QString &resourcePath );
public     :  virtual                               void ohrea_scrollToAnchor (const QString &resourcePath );
public     :  virtual                               void ohrea_setHtml (const QString &rcQString, const QUrl &baseUrl );
public     :  virtual                               void ohrea_setPlainText (const QString &rcQString, const QUrl &baseUrl );
public     :  virtual                               void ohrea_setSource (const QUrl &link );
public     :  virtual                               void propertyActivated ( );
public     :  virtual                               void propertyClosed ( );
public     :  virtual                               void propertyOpened ( );
protected  :  private slots:                        void slot_loadFinished (bool bState );
protected  :  private slots:                        void slot_loadStarted ( );
public     :  public slots:                         void slot_zoomDefault ( );
protected  :  private slots:                        void slot_zoomIn ( );
protected  :  private slots:                        void slot_zoomOut ( );
public     :  virtual                               QWidget *widget ( );
public     :                                             ~OWEBControl ( );

};

